/* razno.h
 * Copyright (C) 2004 Djukic Marko, Pernus Klemen, Zagar Miha
 * For conditions of distribution and use, see the copyright notice in main.cpp
 */
#ifndef _RAZNO_H_
#define _RAZNO_H_

#include "point.h"
#include "objects.h"

class Mouse {
public:
	//ali je pritisnjena ali ne
	unsigned char pressed;
	//kater gumb je pritisnjen 1..levi 2..desni
	unsigned char button;
	//je 1 ce je slo za double click ... zato da vem ce moram up tudi upostevat
	unsigned char double_click;
	//tocke, kjer se je pritisk zacel, kjer je bil prejsen move in kjer je sedaj
	Point *start, *previous, *current;
	//kaksne barve je trenutni objekt ki ga risem
	Color *color;
	//kaksne debeline je tenutni objekt ki ga risem
	unsigned int width;

	//tisti objekt v seznamu, ki ga drzim v rokah
	Object *holding_object;
	//tocka kjer objekt drzim
	//0..na objektu, 1..na prvem tockau 2..na drugem tockau
	unsigned int holding_object_vertex;
	//tista omejitev v seznamu, ki jo drzim v rokah
	Constraint *holding_constraint;

	//konstruktorcek
	Mouse() {
		pressed = 0;
		button = 0;
		start = new Point();
		previous = new Point();
		current = new Point();

		width = 1;
		color = new Color(0,0,0);

		holding_object = NULL;
		holding_object_vertex = 0;
		holding_constraint = NULL;
	}

	//destruktorcek
	~Mouse() {
		delete start;
		delete previous;
		delete current;

		delete color;
	}
};

#endif //_RAZNO_H_