/* tuner.cpp
 * Copyright (C) 2004 Djukic Marko, Pernus Klemen, Zagar Miha
 * For conditions of distribution and use, see the copyright notice in main.cpp
 */
#include "tuner.h"

FXDEFMAP(TunerWindow) TunerWindowMap[]={
	FXMAPFUNC(SEL_CHANGED,		TunerWindow::ID_CONNECTION_1_TYPE, TunerWindow::connection_1_type),
	FXMAPFUNC(SEL_UPDATE,		TunerWindow::ID_CONNECTION_1_TYPE_PAINT, TunerWindow::connection_1_type),

	FXMAPFUNC(SEL_CHANGED,		TunerWindow::ID_ANGLE_1_TYPE, TunerWindow::angle_1_type),
	FXMAPFUNC(SEL_UPDATE,		TunerWindow::ID_ANGLE_1_TYPE_PAINT, TunerWindow::angle_1_type),
	FXMAPFUNC(SEL_CHANGED,		TunerWindow::ID_ANGLE_2_TYPE, TunerWindow::angle_2_type),
	FXMAPFUNC(SEL_UPDATE,		TunerWindow::ID_ANGLE_2_TYPE_PAINT, TunerWindow::angle_2_type),

	FXMAPFUNC(SEL_UPDATE,		TunerWindow::ID_COMPLEX_LINE_CANVAS, TunerWindow::complex_line_canvas_paint),
	FXMAPFUNC(SEL_CHANGED,		TunerWindow::ID_COMPLEX_LINE_1_EPS, TunerWindow::complex_line_canvas_mouse_up),
	FXMAPFUNC(SEL_CHANGED,		TunerWindow::ID_COMPLEX_LINE_2_EPS, TunerWindow::complex_line_canvas_mouse_up),
	FXMAPFUNC(SEL_LEFTBUTTONPRESS,	TunerWindow::ID_COMPLEX_LINE_CANVAS, TunerWindow::complex_line_canvas_mouse_down),
	FXMAPFUNC(SEL_LEFTBUTTONRELEASE,TunerWindow::ID_COMPLEX_LINE_CANVAS, TunerWindow::complex_line_canvas_mouse_up),
	FXMAPFUNC(SEL_MOTION,			TunerWindow::ID_COMPLEX_LINE_CANVAS, TunerWindow::complex_line_canvas_mouse_move),
}; 

FXIMPLEMENT(TunerWindow,FXDialogBox,TunerWindowMap,ARRAYNUMBER(TunerWindowMap))


TunerWindow::TunerWindow(FXWindow *owner, AI *_ai, Recognizer *rec):
  FXDialogBox(owner,"Asaai - AI",DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,0,0,600,500, 5,5,5,5, 0,0){

	FXShutter *shutter_frame;
	FXShutterItem *shutter_item;
	FXVerticalFrame *contents;
	FXHorizontalFrame *buttons;
	FXSlider *slider;
	FXHorizontalFrame *horizontal;
	FXVerticalFrame *vertical;
	FXGroupBox *gb;

	//asajnam AI modul
	ai = _ai;
	//asajna recognizerja
	recognizer = rec;

	//mis ni pritisnjena
	mouse_down = 0;
	
	contents = new FXVerticalFrame(this,LAYOUT_FILL_X|LAYOUT_FILL_Y);
	
	shutter_frame = new FXShutter(contents,NULL,0,FRAME_SUNKEN|LAYOUT_FILL_Y|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,0,0,0,0,0,0,0,0,0,0);

	//////////////////////////////////
	//  CONNECTION STUFF
	//////////////////////////////////
	shutter_item = new FXShutterItem(shutter_frame,"Connection",NULL,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,0,0,0,0,10,10,10,10,10,10);
	horizontal = new FXHorizontalFrame(shutter_item->getContent(),LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_CENTER_X|LAYOUT_CENTER_Y);
	
	//////////////////////////////////
	//  stik tipa 1
	/////////////////////////////////
	gb = new FXGroupBox(horizontal,"",FRAME_RIDGE|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT|LAYOUT_CENTER_X|LAYOUT_CENTER_Y,0,0,250,290);
	vertical = new FXVerticalFrame(gb,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	new FXLabel(vertical,"Kaj je zate se stik crt?",NULL,LAYOUT_CENTER_X);
	//okno v katerega risem crte za stik tipa 1
	connection_1_type_canvas = new FXCanvas(vertical,this,ID_CONNECTION_1_TYPE_PAINT,FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	//slider s katerim premikam razmik
	slider = new FXSlider(vertical,&connection_1_type_data_target,FXDataTarget::ID_VALUE,LAYOUT_FILL_X|SLIDER_INSIDE_BAR,0,0,0,0,0,0,0,0);
	slider->setRange(0,50);

	connection_1_type_data_target.connect(ai->connection_type_1_epsilon);
	connection_1_type_data_target.setTarget(this);
	connection_1_type_data_target.setSelector(ID_CONNECTION_1_TYPE);

	
	//////////////////////////////////
	//  ANGLE STUFF
	//////////////////////////////////
	shutter_item = new FXShutterItem(shutter_frame,"Angle",NULL,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,0,0,0,0,10,10,10,10,10,10);
	horizontal = new FXHorizontalFrame(shutter_item->getContent(),LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_CENTER_X|LAYOUT_CENTER_Y);
	
	//////////////////////////////////////////
	//  kdaj je crta se navpicna oz vodoravna
	//////////////////////////////////////////
	gb = new FXGroupBox(horizontal,"",FRAME_RIDGE|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT|LAYOUT_CENTER_X|LAYOUT_CENTER_Y,0,0,250,290);
	vertical = new FXVerticalFrame(gb,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	new FXLabel(vertical,"Kaj je zate se navpicna/vodoravna crta?",NULL,LAYOUT_CENTER_X);
	//okno v katerega risem crte za vodoravnost/navpicnost
	angle_1_type_canvas = new FXCanvas(vertical,this,ID_ANGLE_1_TYPE_PAINT,FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	//slider s katerim premikam razmik
	slider = new FXSlider(vertical,&angle_1_type_data_target,FXDataTarget::ID_VALUE,LAYOUT_FILL_X|SLIDER_INSIDE_BAR,0,0,0,0,0,0,0,0);
	slider->setRange(0,50);

	angle_1_type_data_target.connect(ai->angle_type_1_epsilon);
	angle_1_type_data_target.setTarget(this);
	angle_1_type_data_target.setSelector(ID_ANGLE_1_TYPE);	
	

	//////////////////////////////////
	//  RECOGNIZER STUFF
	//////////////////////////////////
	complex_line_trace = new Trace();

	shutter_item = new FXShutterItem(shutter_frame,"Recognizer",NULL,LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,0,0,0,0,10,10,10,10,10,10);
	horizontal = new FXHorizontalFrame(shutter_item->getContent(),LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_CENTER_X|LAYOUT_CENTER_Y);
	
	gb = new FXGroupBox(horizontal,"",FRAME_RIDGE|LAYOUT_FILL_Y|LAYOUT_FILL_X|LAYOUT_CENTER_X|LAYOUT_CENTER_Y,0,0,0,0);
	vertical = new FXVerticalFrame(gb,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	new FXLabel(vertical,"Set the recognizer parameters.",NULL,LAYOUT_CENTER_X);
	//okno v katerega risem crte za vodoravnost/navpicnost
	complex_line_canvas = new FXCanvas(vertical,this,ID_COMPLEX_LINE_CANVAS,FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y);
	//slider s katerim premikam razmik
	slider = new FXSlider(vertical,&complex_line_1_eps_data_target,FXDataTarget::ID_VALUE,LAYOUT_FILL_X|SLIDER_INSIDE_BAR,0,0,0,0,0,0,0,0);
	slider->setRange(0,10);
	slider = new FXSlider(vertical,&complex_line_2_eps_data_target,FXDataTarget::ID_VALUE,LAYOUT_FILL_X|SLIDER_INSIDE_BAR,0,0,0,0,0,0,0,0);
	slider->setRange(0,5);

	//data target za prvi epsilon
	complex_line_1_eps_data_target.connect(ai->complex_lines_1_epsilon);
	complex_line_1_eps_data_target.setTarget(this);
	complex_line_1_eps_data_target.setSelector(ID_COMPLEX_LINE_1_EPS);	
	//data target za drugi epsilon
	complex_line_2_eps_data_target.connect(ai->complex_lines_2_epsilon);
	complex_line_2_eps_data_target.setTarget(this);
	complex_line_2_eps_data_target.setSelector(ID_COMPLEX_LINE_2_EPS);	
	

	//separator in nato gumbek za OK
	new FXHorizontalSeparator(contents,LAYOUT_FILL_X|SEPARATOR_GROOVE,0,0,0,0,10,10,10,5);

	buttons = new FXHorizontalFrame(contents,LAYOUT_CENTER_X|LAYOUT_FILL_X);
	new FXButton(buttons,"OK",NULL,this,ID_ACCEPT,BUTTON_NORMAL|LAYOUT_RIGHT,0,0,0,0,25,25,5,5);
}

TunerWindow::~TunerWindow(){
}

//stik rob<->rob
long TunerWindow::connection_1_type(FXObject *obj,FXSelector,void*) {
	FXDCWindow dc(connection_1_type_canvas);
	int w,h,w2,h2;

	int diff = (int)ai->connection_type_1_epsilon;

	w = connection_1_type_canvas->getWidth();
	h = connection_1_type_canvas->getHeight();
	
	h2 = h / 2; //polovica visine
	w2 = w / 2; //polovica sirine

	//pobrisem canvas
    dc.setForeground(FXRGB(255,255,255));
	dc.fillRectangle(0,0,w,h);

	dc.setForeground(FXRGB(0,0,0));
	dc.setLineWidth(2);

	dc.drawLine(5,h-5,w2,h2);
	dc.drawLine(w2+diff,h2,w-5+diff,h-5);
	
	dc.setForeground(FXRGB(255,0,0));
	dc.setLineWidth(1);
	dc.drawArc(w2-diff,h2-diff,diff*2,diff*2,0,23040);

	return 1;
}

//kdaje je crta se navpicna / vodoravna
long TunerWindow::angle_1_type(FXObject *obj,FXSelector,void*) {
	FXDCWindow dc(angle_1_type_canvas);
	int w,h,w2,h2;

	int diff = (int)ai->angle_type_1_epsilon;

	w = angle_1_type_canvas->getWidth();
	h = angle_1_type_canvas->getHeight();
	
	h2 = h / 2; //polovica visine
	w2 = w / 2; //polovica sirine

	//pobrisem canvas
    dc.setForeground(FXRGB(255,255,255));
	dc.fillRectangle(0,0,w,h);


	dc.setForeground(FXRGB(255,0,0));
	dc.setLineWidth(1);
	//zgoranja lomljena crta
	dc.drawLine(w2-diff,0,w2+diff,h);
	//spodnja lomljena crta
	dc.drawLine(w2+diff,0,w2-diff,h);
	
	dc.setForeground(FXRGB(0,0,0));
	dc.setLineWidth(2);
	//sredinska crta
	dc.drawLine(w2,0,w2,h);

	return 1;
}

//kdaj je lomljena crta ze ravna
long TunerWindow::angle_2_type(FXObject *obj,FXSelector,void*) {
	FXDCWindow dc(angle_2_type_canvas);
	int w,h,w2,h2;

	int diff = (int)ai->angle_type_2_epsilon;

	w = angle_2_type_canvas->getWidth();
	h = angle_2_type_canvas->getHeight();
	
	h2 = h / 2; //polovica visine
	w2 = w / 2; //polovica sirine

	//pobrisem canvas
    dc.setForeground(FXRGB(255,255,255));
	dc.fillRectangle(0,0,w,h);


	dc.setForeground(FXRGB(255,0,0));
	dc.setLineWidth(1);
	//zgoranja lomljena crta
	dc.drawLine(0,h2,w2,h2-diff);
	dc.drawLine(w2,h2-diff,w,h2);
	//spodnja lomljena crta
	dc.drawLine(0,h2,w2,h2+diff);
	dc.drawLine(w2,h2+diff,w,h2);
	
	dc.setForeground(FXRGB(0,0,0));
	dc.setLineWidth(2);
	//sredinska crta
	dc.drawLine(0,h2,w,h2);

	return 1;
}

//pobrisem ekran na belo
long TunerWindow::complex_line_canvas_paint(FXObject*,FXSelector,void*) {
	return 1;
}
//inicializacij traca 
long TunerWindow::complex_line_canvas_mouse_down(FXObject*,FXSelector,void*) {
	FXDCWindow dc(complex_line_canvas);

	dc.setForeground(FXRGB(255,255,255));
	dc.fillRectangle(0,0,complex_line_canvas->getWidth(),complex_line_canvas->getHeight());

	
	mouse_down = 1; //povem da je mis kliknena

    delete complex_line_trace;
	complex_line_trace = new Trace(); //ustvarim new trace
	
	return 1;
}

long TunerWindow::complex_line_canvas_mouse_move(FXObject*,FXSelector,void *ptr) {
	FXEvent *ev=(FXEvent*)ptr;
	
	if (mouse_down){ //ce je mis pritisnjena
		FXDCWindow dc(complex_line_canvas);
		dc.setForeground(FXRGB(0,0,0));
    
		//narisem v trace
		complex_line_trace->set_line(new Point(ev->last_x, ev->last_y), new Point(ev->win_x, ev->win_y));
		// Draw line
		dc.drawLine(ev->last_x, ev->last_y, ev->win_x, ev->win_y);
	}

	return 1;
}

//naredim evaluacijo celotne stvari
long TunerWindow::complex_line_canvas_mouse_up(FXObject*,FXSelector,void*) {
	FXDCWindow dc(complex_line_canvas);
	unsigned int i;
	Object *o;

	mouse_down = 0;

	//pobrisem canvas	
	dc.setForeground(FXRGB(255,255,255));
	dc.fillRectangle(0,0,complex_line_canvas->getWidth(),complex_line_canvas->getHeight());

	dc.setForeground(FXRGB(127,127,127));
	for (i = 0; i < complex_line_trace->get_nr_points(); i++) {
		dc.drawPoint(complex_line_trace->get_point(i)->x,complex_line_trace->get_point(i)->y);
	}

	dc.setForeground(FXRGB(0,0,0));
	if (recognizer->recognize(complex_line_trace) == 1) { //pomeni da je prepoznal
		while ((o = recognizer->get_object()) != NULL) {
			dc.drawLine(o->get_vertex_point(1)->x,o->get_vertex_point(1)->y,o->get_vertex_point(2)->x,o->get_vertex_point(2)->y); 
		}
	}


	return 1;
}




